const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const counterparties = sequelize.define(
    'counterparties',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

type: {
        type: DataTypes.ENUM,
      
      

        values: [

"customer",


"vendor",


"employee",


"other"

        ],

      },

code: {
        type: DataTypes.TEXT,
      
      

      },

name: {
        type: DataTypes.TEXT,
      
      

      },

national_id: {
        type: DataTypes.TEXT,
      
      

      },

economic_code: {
        type: DataTypes.TEXT,
      
      

      },

phone: {
        type: DataTypes.TEXT,
      
      

      },

address: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  counterparties.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity























    db.counterparties.hasMany(db.contracts, {
      as: 'contracts_counterparty',
      foreignKey: {
          name: 'counterpartyId',
      },
      constraints: false,
    });





    db.counterparties.hasMany(db.letters_of_credit, {
      as: 'letters_of_credit_counterparty',
      foreignKey: {
          name: 'counterpartyId',
      },
      constraints: false,
    });










    db.counterparties.hasMany(db.journal_lines, {
      as: 'journal_lines_counterparty',
      foreignKey: {
          name: 'counterpartyId',
      },
      constraints: false,
    });














//end loop



    db.counterparties.belongsTo(db.businesses, {
      as: 'business',
      foreignKey: {
        name: 'businessId',
      },
      constraints: false,
    });




    db.counterparties.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.counterparties.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return counterparties;
};


